// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type GetProductListReq struct {
	Cid    int64  `form:"cid"`
	Size   uint32 `form:"size"`
	Page   uint32 `form:"page,optional"`
	IsDemo uint32 `form:"is_demo,optional"`
}

type GetProductListRsp struct {
	Ob          Ob     `json:"ob"`
	TypeName    string `json:"typeName"`
	Description string `json:"description"`
}

type Ob struct {
	Items []Items `json:"items"`
	Meta  Meta    `json:"_meta"`
}

type Items struct {
	Id           int64  `json:"id"`
	Sn           string `json:"sn"`
	Title        string `json:"title"`
	Cover        string `json:"cover"`
	Intro        string `json:"intro"`
	CoverImg     string `json:"cover_img"`
	IsEnv        int64  `json:"isEnv"`
	IsMicro      int64  `json:"isMicro"`
	SizeNum      uint32 `json:"sizeNum"`
	MinPrice     int64  `json:"minPrice"`
	CoverDefault string `json:"coverDefault"`
}

type GetSuccessRecommandReq struct {
	Num  uint32 `form:"num"`
	Size uint32 `form:"size"`
	Sn   string `form:"sn"`
}

type GetSuccessRecommandRsp struct {
	Title        string `json:"title"`
	Cover        string `json:"cover"`
	CoverImg     string `json:"coverImg"`
	Sn           string `json:"sn"`
	Id           int64  `json:"id"`
	SkuId        int64  `json:"skuId"`
	CoverDefault string `json:"coverDefault"`
}

type GetSizeByProductRsp struct {
	Id       int64      `json:"id"`
	Name     string     `json:"name"`
	Children []Children `json:"children"`
}

type Children struct {
	Id           int64         `json:"id"`
	Name         string        `json:"name"`
	Cycle        int           `json:"cycle"`
	ChildrenList []ChildrenObj `json:"children"`
}

type ChildrenObj struct {
	Id        int64      `json:"id"`
	Name      string     `json:"name"`
	PriceList []PriceObj `json:"price_list"`
}

type PriceObj struct {
	Num   int     `json:"num"`
	Price float64 `json:"price"`
}

type GetProductDesignReq struct {
	Sn string `form:"sn"`
}

type GetProductDesignRsp struct {
	ProductId  int64  `json:"product_id"`
	TemplateId int64  `json:"template_id"`
	SizeId     int64  `json:"size_id"`
	OptionalId int64  `json:"optional_id"`
	Cover      string `json:"cover"`
	Info       string `json:"info"`
}

type DesignGatherReq struct {
	Data string `json:"data"`
}

type DesignGatherRsp struct {
	Sn string `json:"sn"`
}

type GetProductInfoReq struct {
	Pid                string `form:"pid"`
	Size               uint32 `form:"size"`
	ClientNo           string `form:"client_no"`
	HaveCloudRendering bool   `form:"haveCloudRendering,optional"`
}

type GetProductInfoRsp struct {
	Id             int64          `json:"id"`
	Type           int64          `json:"type"`
	Title          string         `json:"title"`
	IsEnv          int64          `json:"isEnv"`
	IsMicro        int64          `json:"isMicro"`
	TypeName       string         `json:"typeName"`
	IsLowRendering bool           `json:"is_low_rendering"`
	IsRemoveBg     bool           `json:"is_remove_bg"`
	Materials      []MaterialItem `json:"materials"`
	Sizes          []SizeItem     `json:"sizes"`
	Templates      interface{}    `json:"templates"`
	Prices         interface{}    `json:"prices"`
	LastDesign     interface{}    `json:"last_design"`
	RenderDesign   interface{}    `json:"render_design"`
	Colors         interface{}    `json:"colors"`
}

type SizeItem struct {
	Id              int64     `json:"id"`
	Title           SizeTitle `json:"title"`
	Capacity        string    `json:"capacity"`
	Cover           string    `json:"cover"`
	Sort            int64     `json:"sort"`
	PartsCanDeleted bool      `json:"parts_can_deleted"`
}

type SizeTitle struct {
	Cm   string `json:"cm"`
	Inch string `json:"inch"`
}

type MaterialItem struct {
	Id    int64  `json:"id"`
	Title string `json:"title"`
}

type SaveDesignReq struct {
	Data string `json:"data"` //加密信息
}

type SaveDesignRsp struct {
	Sn string `json:"sn"`
}

type SaveDesignReqRealStruct struct {
	ProductId  int64      `json:"product_id"`
	SizeId     int64      `json:"size_id"`
	OptionalId int64      `json:"optional_id"`
	TemplateId int64      `json:"template_id"`
	Sn         string     `json:"sn"`
	Data       DesignData `json:"data"`
	Cover      string     `json:"cover"`
	PageGuid   string     `json:"pageGuid"`
}

type DesignData struct {
	MainColor      ColorFill     `json:"MainColor"`
	SecondaryColor ColorFill     `json:"SecondaryColor"`
	Logo           DesignLogo    `json:"Logo"`
	Slogan         DesignSlogan  `json:"Slogan"`
	QRcode         DesignQRcode  `json:"QRcode"`
	Website        DesignWebsite `json:"Website"`
	Phone          DesignPhone   `json:"Phone"`
	Address        DesignAddress `json:"Address"`
}

type DesignAddress struct {
	Text   string `json:"text"`
	IfShow bool   `json:"ifShow"`
}

type DesignPhone struct {
	Text   string `json:"text"`
	IfShow bool   `json:"ifShow"`
}

type DesignWebsite struct {
	Text   string `json:"text"`
	IfShow bool   `json:"ifShow"`
}

type DesignQRcode struct {
	Text    string `json:"text"`
	SvgPath string `json:"svgPath"`
	IfShow  bool   `json:"ifShow"`
}

type DesignSlogan struct {
	Text   string `json:"text"`
	IfShow bool   `json:"ifShow"`
}

type DesignLogo struct {
	Material     string   `json:"material"`
	MaterialName string   `json:"materialName"`
	MaterialTime string   `json:"materialTime"`
	Fill         string   `json:"fill"`
	FillName     string   `json:"fill_name"`
	Colors       []string `json:"colors"`
}

type ColorFill struct {
	Fill string `json:"fill"`
}

type OtherProductListReq struct {
	Cid  int64  `form:"cid"`
	Num  int64  `form:"num"`
	Size uint32 `form:"size"`
}

type OtherProductListRsp struct {
	Title        string `json:"title"`
	Cover        string `json:"cover"`
	CoverImg     string `json:"cover_img"`
	CoverDefault string `json:"cover_default"`
	Sn           string `json:"sn"`
	Id           int64  `json:"id"`
	SkuId        int64  `json:"sku_id"`
}

type GetRecommandProductListReq struct {
	Size uint32 `form:"size,optional"`
	Num  int64  `form:"num,optional"`
	Sn   string `form:"sn"`
}

type GetRecommandProductListRsp struct {
	Id           int64  `json:"id"`
	Sn           string `json:"sn"`
	Title        string `json:"title"`
	TitleCn      string `json:"title_cn"`
	Cover        string `json:"cover"`
	CoverImg     string `json:"cover_img"`
	CoverDefault string `json:"cover_default"`
	Intro        string `json:"intro"`
	IsRecommend  int64  `json:"is_recommend"`
	MinPrice     int64  `json:"min_price"`
}

type GetTagProductListReq struct {
	Cid         int64  `form:"cid,optional"`          //分类id
	Size        uint32 `form:"size,optional"`         //尺寸
	WithProduct bool   `form:"with_product,optional"` //是否携带分类下的产品
}

type GetTagProductListRsp struct {
	TotalCategoryProduct int       `json:"total_category_product"`
	TagList              []TagItem `json:"tag_list"`
}

type TagItem struct {
	TypeName       string        `json:"type_name"`
	TypeId         int64         `json:"type_id"`
	Icon           string        `json:"icon"`
	Sort           int64         `json:"sort"`
	LevelPrefix    string        `json:"level_prefix"`
	TagProductList []interface{} `json:"tag_product_list"` //分类下的产品
	ChildTagList   []*TagItem    `json:"child_tag_list"`
}

type TagProduct struct {
	ProductId           int64              `json:"product_id"`
	Sn                  string             `json:"sn"`
	Title               string             `json:"title"`
	Cover               string             `json:"cover"`
	SizeNum             uint32             `json:"size_num"`
	MinPrice            int64              `json:"min_price"`
	CoverDefault        []CoverDefaultItem `json:"cover_default"`
	HaveOptionalFitting bool               `json:"have_optional_fitting"`
	Recommended         bool               `json:"recommended"`
}

type CoverDefaultItem struct {
	Tag   string `json:"tag"`
	Cover string `json:"cover"`
}

type GetRenderDesignReq struct {
	Sn string `form:"sn"`
}

type GetRenderDesignRsp struct {
	Id         int64       `json:"id"`
	Info       interface{} `json:"info"`
	OptionalId int64       `json:"optional_id"`
	SizeId     int64       `json:"size_id"`
	TemplateId int64       `json:"template_id"`
	LogoColor  []string    `json:"logo_color"`
}

type GetModelByPidReq struct {
	Pid string `form:"pid"` //实际上是产品sn
}

type GetPriceByPidReq struct {
	Pid string `form:"pid"`
}

type GetPriceByPidRsp struct {
	Items     []PriceItem `json:"items"`
	MinPrice  float64     `json:"min_price"`
	MaxPrice  float64     `json:"max_price"`
	StepRange []StepRange `json:"step_range"`
}

type StepRange struct {
	Begin int64   `json:"begin"`
	End   int64   `json:"end"`
	Price float64 `json:"price"`
}

type PriceItem struct {
	Num      int64 `json:"num"`
	TotalNum int64 `json:"total_num"`
	Price    int64 `json:"price"`
}

type GetSizeByPidReq struct {
	Pid string `form:"pid"`
}

type GetSizeByPidRsp struct {
	Id              int64       `json:"id"` //尺寸id
	Title           interface{} `json:"title"`
	Capacity        string      `json:"capacity"`          //容量、尺寸、尺码描述
	Cover           string      `json:"cover"`             //缩略图
	PartsCanDeleted bool        `json:"parts_can_deleted"` //用户可否删除配件
	ModelId         int64       `json:"model_id"`          //产品主模型id
	IsPopular       bool        `json:"is_popular"`        //是否受欢迎
	MinPrice        float64     `json:"min_price"`         //最小价格
}

type GetTemplateByPidReq struct {
	Pid                  string `form:"pid"`
	Size                 uint32 `form:"size"`
	ProductTemplateTagId int64  `form:"product_template_tag_id"`
}

type GetFittingByPidReq struct {
	Pid string `form:"pid"`
}

type GetFittingByPidRsp struct {
	Id          int64       `json:"id"`
	MaterialImg string      `json:"material_img"`
	Title       string      `json:"title"`
	Price       int64       `json:"price"`
	IsPopular   bool        `json:"is_popular"`
	ModelInfo   interface{} `json:"model_info"`
}

type GetLightByPidReq struct {
	Pid string `form:"pid"`
}

type GetRenderSettingByPidReq struct {
	Pid      string `form:"pid"`
	ClientNo string `form:"client_no,optional"`
}

type GetRenderSettingByPidRsp struct {
	Id             int64       `json:"id"`               //产品id
	Type           int64       `json:"type"`             //产品typeid
	Title          string      `json:"title"`            //产品名称
	IsEnv          int64       `json:"isEnv"`            //产品标签之一
	IsMicro        int64       `json:"isMicro"`          //产品标签之一
	TypeName       string      `json:"typeName"`         //产品类型名称
	IsLowRendering bool        `json:"is_low_rendering"` //低质量画质渲染开关
	IsRemoveBg     bool        `json:"is_remove_bg"`     //logo上传是否去背景
	RenderDesign   bool        `json:"render_design"`    //是否拥有云渲染设计方案
	LastDesign     bool        `json:"last_design"`      //是否拥有千人千面设计方案
	Colors         interface{} `json:"colors"`
}

type GetLastProductDesignRsp struct {
	Id         int64       `json:"id"`
	OptionalId int64       `json:"optional_id"`
	SizeId     int64       `json:"size_id"`
	LogoColor  interface{} `json:"logo_color"`
	Info       interface{} `json:"info"`
}

type HomePageRecommendProductListReq struct {
	Size uint32 `form:"size"`
}

type HomePageRecommendProductListRsp struct {
	Id                  int64  `json:"id"`
	Sn                  string `json:"sn"`
	Title               string `json:"title"`
	Cover               string `json:"cover"`
	SizeNum             uint32 `json:"size_num"`
	MinPrice            int64  `json:"min_price"`
	CoverDefault        string `json:"cover_default"`
	HaveOptionalFitting bool   `json:"have_optional_fitting"`
}

type Request struct {
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type File struct {
	Filename string              `fsfile:"filename"`
	Header   map[string][]string `fsfile:"header"`
	Size     int64               `fsfile:"size"`
	Data     []byte              `fsfile:"data"`
}

type Meta struct {
	TotalCount  int64 `json:"totalCount"`
	PageCount   int64 `json:"pageCount"`
	CurrentPage int   `json:"currentPage"`
	PerPage     int   `json:"perPage"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
