package websocket_data

// websocket数据交互
type DataTransferData struct {
	T string      `json:"t"` //消息类型
	D interface{} `json:"d"` //传递的消息
}

// websocket接受要云渲染处理的数据
type RenderImageReqMsg struct {
	RenderId   string     `json:"render_id"` //渲染id
	RenderData RenderData `json:"render_data"`
}
type RenderData struct {
	TemplateTagId int64       `json:"template_tag_id"` //模板标签id
	ProductId     int64       `json:"product_id"`      //产品id
	Data          interface{} `json:"data"`            //面片数据
	UserId        int64       `json:"user_id"`         //用户id
	GuestId       int64       `json:"guest_id"`        //游客id
}

// websocket发送渲染完的数据
type RenderImageRspMsg struct {
	RenderId string `json:"render_id"` //渲染id
	Image    string `json:"image"`     //渲染结果图片
}

// 渲染服务器回调数据
type RenderImageNotify struct {
	TaskId string `json:"task_id"`
	Image  string `json:"image"`
}
type ThirdPartyLoginRspMsg struct {
	//websocket三方登录的通知数据
	Token string `json:"token"`
}

// 发送到渲染组装的mq数据
type AssembleRenderData struct {
	TaskId     string     `json:"task_id"`
	RenderId   string     `json:"render_id"`
	RenderData RenderData `json:"render_data"`
}
